//funkce pouzite pri importu dat z API

//------------------------------------------------------------------------------
//deklarace funkci definovanych v jinych souborech
procedure SerieChange(sender:TObject); forward;  //LabForGg.fceForm.pas
procedure butOwnerIdOnClick(sender:TObject); forward;  //LabForGg.fceForm.pas
procedure cbLabViewOnChange(sender:TObject); forward;  //LabForGg.fceForm.pas
//------------------------------------------------------------------------------

procedure CheckXmlInit;
var n:integer;
begin
  //inicializuje popis struktur jednotlivych XML
  //posledni zmena 23.11.2020
  n:=-1;
  Inc(n); rXmlBasic.Items[n].sName:='CreatedUtc';
  Inc(n); rXmlBasic.Items[n].sName:='DeepLink';
  Inc(n); rXmlBasic.Items[n].sName:='Description';
  Inc(n); rXmlBasic.Items[n].sName:='FirebaseDynamicLink';
  Inc(n); rXmlBasic.Items[n].sName:='Id';
  Inc(n); rXmlBasic.Items[n].sName:='IsArchived';
  Inc(n); rXmlBasic.Items[n].sName:='IsComplete';
  Inc(n); rXmlBasic.Items[n].sName:='IsTest';
  Inc(n); rXmlBasic.Items[n].sName:='KeyImageUrl';
  Inc(n); rXmlBasic.Items[n].sName:='Location';
  Inc(n); rXmlBasic.Items[n].sName:='OwnerPublicGuid';
  Inc(n); rXmlBasic.Items[n].sName:='PublishedUtc';
  Inc(n); rXmlBasic.Items[n].sName:='RatingsAverage';
  Inc(n); rXmlBasic.Items[n].sName:='RatingsTotalCount';
  Inc(n); rXmlBasic.Items[n].sName:='SmartLink';
  Inc(n); rXmlBasic.Items[n].sName:='StagesTotalCount';
  Inc(n); rXmlBasic.Items[n].sName:='Title';
  Inc(n); rXmlBasic.Items[n].sName:='Visibility';
  rXmlBasic.nCount:=n+1;

  n:=-1;
  Inc(n); rXmlLab.Items[n].sName:='AwardImageAsBase64String';
  Inc(n); rXmlLab.Items[n].sName:='AwardImageUrl';
  Inc(n); rXmlLab.Items[n].sName:='AwardVideoYouTubeId';
  Inc(n); rXmlLab.Items[n].sName:='CompletionAwardMessage';
  Inc(n); rXmlLab.Items[n].sName:='CompletionCode';
  Inc(n); rXmlLab.Items[n].sName:='DeleteAwardImage';
  Inc(n); rXmlLab.Items[n].sName:='Description';
  Inc(n); rXmlLab.Items[n].sName:='DescriptionVideoYouTubeId';
  Inc(n); rXmlLab.Items[n].sName:='FindCodeHashBase16';
  Inc(n); rXmlLab.Items[n].sName:='GeofencingRadius';
  Inc(n); rXmlLab.Items[n].sName:='Id';
  Inc(n); rXmlLab.Items[n].sName:='IsComplete';
  Inc(n); rXmlLab.Items[n].sName:='KeyImage';
  Inc(n); rXmlLab.Items[n].sName:='KeyImageAsBase64String';
  Inc(n); rXmlLab.Items[n].sName:='KeyImageUrl';
  Inc(n); rXmlLab.Items[n].sName:='LastUpdateDateTimeUtc';
  Inc(n); rXmlLab.Items[n].sName:='Location';
  Inc(n); rXmlLab.Items[n].sName:='Question';
  Inc(n); rXmlLab.Items[n].sName:='Title';
  rXmlLab.nCount:=n+1;

  n:=-1;
  Inc(n); rXmlDetail.Items[n].sName:='AwardImageAsBase64String';
  Inc(n); rXmlDetail.Items[n].sName:='AwardMessage';
  Inc(n); rXmlDetail.Items[n].sName:='AwardVideoYouTubeId';
  Inc(n); rXmlDetail.Items[n].sName:='ClonedSourceAdventureId';
  Inc(n); rXmlDetail.Items[n].sName:='CompletedGeocachesCount';
  Inc(n); rXmlDetail.Items[n].sName:='DeepLink';
  Inc(n); rXmlDetail.Items[n].sName:='Description';
  Inc(n); rXmlDetail.Items[n].sName:='FirebaseDynamicLink';
  Inc(n); rXmlDetail.Items[n].sName:='GeocacheSummaries';
  Inc(n); rXmlDetail.Items[n].sName:='Id';
  Inc(n); rXmlDetail.Items[n].sName:='IsComplete';
  Inc(n); rXmlDetail.Items[n].sName:='IsLinear';
  Inc(n); rXmlDetail.Items[n].sName:='IsTest';
  Inc(n); rXmlDetail.Items[n].sName:='KeyImageAsBase64String';
  Inc(n); rXmlDetail.Items[n].sName:='KeyImageUrl';
  Inc(n); rXmlDetail.Items[n].sName:='LastUpdateDateTimeUtc';
  Inc(n); rXmlDetail.Items[n].sName:='Location';
  Inc(n); rXmlDetail.Items[n].sName:='OwnerId';
  Inc(n); rXmlDetail.Items[n].sName:='OwnerUsername';
  Inc(n); rXmlDetail.Items[n].sName:='PublishedUtc';
  Inc(n); rXmlDetail.Items[n].sName:='RatingsAverage';
  Inc(n); rXmlDetail.Items[n].sName:='RatingsTotalCount';
  Inc(n); rXmlDetail.Items[n].sName:='SmartLinkString';
  Inc(n); rXmlDetail.Items[n].sName:='StagesTotalCount';
  Inc(n); rXmlDetail.Items[n].sName:='TestAdventureId';
  Inc(n); rXmlDetail.Items[n].sName:='Title';
  Inc(n); rXmlDetail.Items[n].sName:='TotalGeocachesCount';
  Inc(n); rXmlDetail.Items[n].sName:='Visibility';
  rXmlDetail.nCount:=n+1;
end;

function CheckXmlIndexOfName(aData:T_XML_STRUCT; sName:string):integer;
var i:integer;
begin
  //vyhleda polozku v popisu struktury
  Result:=-1;
  for i:=0 to aData.nCount-1 do begin
    if(aData.Items[i].sName=sName) then begin
      Result:=i;
      break;
    end;
  end;
end;

procedure CheckXmlVersion(Xml:TJclSimpleXMLElem; aData:T_XML_STRUCT; sType:string);
var i,j:integer;
    elem: TJclSimpleXMLElem;
    sErr:string;
begin
  //otestuje, zda v XML jsou ocekavane polozky a neni tam nic navic
  for i:=0 to Xml.Items.count-1 do begin
    elem:=XML.Items[i];
    j:=CheckXmlIndexOfName(aData,elem.name);
    if(j<0) then sErr:=sErr+'neznamy element: '+elem.name+CRLF
    else aData.Items[j].bExist:=true;
  end;
  for i:=0 to aData.nCount-1 do begin
    if(aData.Items[i].bExist<>true) then sErr:=sErr+'chybi element: '+aData.Items[i].sName+CRLF;
  end;
  if(sErr<>'') then ShowMessage('WARN: zmena XML formatu '+sType+CRLF+CRLF+sErr);
end;

procedure CheckXmlVersionBasic(Xml:TJclSimpleXML);
begin
  if(rXmlBasic.nCount=0) then CheckXmlInit();
  CheckXmlVersion(Xml.Root,rXmlBasic, 'Basic Info');
end;

procedure CheckXmlVersionDetail(Xml:TJclSimpleXML);
var elem: TJclSimpleXMLElem;
begin
  if(rXmlDetail.nCount=0) then CheckXmlInit();
  CheckXmlVersion(Xml.Root,rXmlDetail, 'Detail Info');
  //a jeste zkontrolujeme strukturu jedne labky
  elem:=XML.Root.Items.Itemnamed['GeocacheSummaries'];
  elem:=elem.Items.Itemnamed['GeocacheSummaryModel']
  CheckXmlVersion(elem,rXmlLab, 'Info o 1 LABce');
end;

function CmpGetForm:boolean;  //nacte pro porovnani poradi labek data z formulare
var i,j:integer;
begin
  Result:=false;
  //zjistime informace o labkach v databazi
  rCmpOld.sLabId:=GgForm_eIdTag.Text;
  rCmpOld.sSerieName:=AnsiToUtf(GgForm_eName.Text);
  rCmpOld.nCount:=0;
  rCmpOld.bCoord:=true; //je mozne porovnavat podle souradnic
  for i:=0 to GgForm_cbCount.ItemIndex do begin //vsechny labky serie v databazi
    rCmpOld.Items[rCmpOld.nCount].sGc:='';
    //jmeno pro porovnani prevedeme na ASCII a mala nismena
    rCmpOld.Items[rCmpOld.nCount].sName:=Trim(LowerCase(UtfToAscii(AnsiToUtf(aLab[rCmpOld.nCount].sName))));
    rCmpOld.Items[rCmpOld.nCount].sLabIdOrd:=aLab[rCmpOld.nCount].sLabIdOrd;
    rCmpOld.Items[rCmpOld.nCount].sCoord:=aLab[rCmpOld.nCount].sCoord;
    rCmpOld.Items[rCmpOld.nCount].idx:=-1;
    rCmpOld.Items[rCmpOld.nCount].iCmpType:=0;
    rCmpOld.Items[rCmpOld.nCount].iOk:=0;
    for j:=0 to i-1 do begin
      if(rCmpOld.Items[rCmpOld.nCount].sCoord=rCmpOld.Items[j].sCoord) then rCmpOld.bCoord:=false;
    end;
    Inc(rCmpOld.nCount);
  end;
  Result:=true;
end;

function CmpGetXml(Xml:TJclSimpleXML):boolean; //nacte pro porovnani poradi labek data z XML z API
var s:string;
    i,j:integer;
    x,y:extended;
    elem,eItems: TJclSimpleXMLElem;
begin
  Result:=false;
  rCmpNew.bCoord:=true;  //je mozne porovnavat podle souradnic
  rCmpNew.sLabId:=XML.Root.Items.Itemnamed['Id'].Value;
  rCmpNew.sSerieName:=XML.Root.Items.Itemnamed['Title'].Value;
  eItems:=XML.Root.Items.Itemnamed['GeocacheSummaries'];           //pocet labek v serii
  rCmpNew.nCount:=eItems.items.count;
  for i:=0 to rCmpNew.nCount-1 do begin
    elem:=eItems.items[i];
    rCmpNew.Items[i].sName:=Trim(LowerCase(UtfToAscii(elem.Items.Itemnamed['Title'].Value)));
    rCmpNew.Items[i].sLabIdOrd:=elem.Items.Itemnamed['Id'].Value;
    elem:=elem.Items.Itemnamed['Location']
    s:=elem.Items.Itemnamed['Latitude'].Value; //souradnice
    s:=s+', '+elem.Items.Itemnamed['Longitude'].Value;
    ParseWgsStr(s,x,y);
    rCmpNew.Items[i].sCoord:=FormatCoordNum(x,y);
    for j:=0 to i-1 do begin
      if(rCmpNew.Items[i].sCoord=rCmpNew.Items[j].sCoord) then rCmpNew.bCoord:=false;
    end;
    rCmpOld.Items[i].idx:=-1;
    rCmpOld.Items[i].iCmpType:=0;
    rCmpOld.Items[i].iOk:=0;
  end;
  Result:=true;
end;

procedure GetBasicInfo(sLabId,sXml:string);
var s,sUrl,sNew:string;
    i,iYear,iMon,iDay:integer;
    dt:TDateTime;
    lat,lon:extended;
    Xml:TJclSimpleXML;
    elem: TJclSimpleXMLElem;
begin
  //pokud neni zadany string s XML, nacteme jej
  if(sXml='') then begin
    sUrl:='https://labs-api.geocaching.com/Api/Adventures/GetAdventureBasicInfo?id='+sLabId;
    {$ifdef DEBUG_HELPER} LDH('3. URL='+sUrl); {$endif}
    HttpAsk('GET',sUrl,'','',sXml);
    StringToFile(sXml,GetOfflineDir()+'ApiBasicIno.xml');
  end;
  //parsujeme ziskane xml
  Xml:=TJclSimpleXml.Create();
  try
    {$ifdef DEBUG_HELPER} LDH('Pred Load'); {$endif}
    //#### pro id=0f088495-bfac-4285-ae87-9be7b89eed03 to tu nejde, kdyz je pouzit
    //#### prevod do ANSI, proto tu musi byt UTF a do ANSI se prevede az jednotlivy string
    Xml.LoadFromString(sXml);
    CheckXmlVersionBasic(Xml);
    GgForm_eIdTag.Text:=XML.Root.Items.Itemnamed['Id'].Value;
    sLabId:=GgForm_eIdTag.Text;
    {$ifdef DEBUG_HELPER} LDH('Po Load'); {$endif}
    //{$ifdef DEBUG_HELPER} LDH('name='+elem.name); {$endif}
    if(GgForm_eName.Text='') then GgForm_eName.Text:=Trim(UtfToAnsi(XML.Root.Items.Itemnamed['Title'].Value)); //toto je i v tom 2. volani
    GgForm_eNameApi.Text:=Trim(UtfToAnsi(XML.Root.Items.Itemnamed['Title'].Value)); //toto je i v tom 2. volani
    //ziskame souradnice ikony serie na mape
    lat:=0;
    {$ifdef DEBUG_HELPER} LDH('Pred Location'); {$endif}
    elem:=XML.Root.Items.Itemnamed['Location'];
    {$ifdef DEBUG_HELPER} LDH('Po Location'); {$endif}
    s:=elem.Items.Itemnamed['Latitude'].Value; //souradnice
    {$ifdef DEBUG_HELPER} LDH('sLat='+s); {$endif}
    if(s<>'') then lat:=StrToFLoat(s);
    lon:=0;
    s:=elem.Items.Itemnamed['Longitude'].Value;
    {$ifdef DEBUG_HELPER} LDH('sLon='+s); {$endif}
    if(s<>'') then lon:=StrToFloat(s);
    //GgForm_eCoord.Text:=FormatCoordNum(lat,lon);
    sNew:=(elem.Items.Itemnamed['Latitude'].Value+', '+elem.Items.Itemnamed['Longitude'].Value);
    {$ifdef DEBUG_HELPER} LDH('COORD='+sNew+'/'+GgForm_eCoord.Text); {$endif}
    //if(GgForm_bGGView.Checked) and (GgForm_eCoord.Text<>sNew)
    //  and (GgForm_eCoord.Text<>'') then AddChangeType('COORD');
    GgForm_eCoord.Text:=sNew;
    //pocet labek v serii je i v podrobnostech, ale pod jmenem <TotalGeocachesCount>
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['StagesTotalCount'].Value);
    if(s<>'') then GgForm_cbCount.ItemIndex:=StrToInt(s)-1;
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['SmartLink'].Value);
    {$ifdef DEBUG_HELPER} LDH('SmartLink='+s); {$endif}
    if(s<>'') then sNew:='https://labs.geocaching.com/goto/'+s
    else sNew:='';
    //pokud jsou nabodenicka, misto SmartLink pouzijeme FirebaseDynamicLink
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['FirebaseDynamicLink'].Value);
    {$ifdef DEBUG_HELPER} LDH('FirebaseDynamicLink='+s); {$endif}
{$ifndef USE_SMARTLINK}
    sNew:=s;
{$endif}
    //protoze jsou pouzita nabodenicka, pouzijeme DynamicLink, ktery na Adnroidu funguje
    if(not IsAscii(sNew)) then begin
      if(GgForm_bGGView.Checked) and (GgForm_eUrlQr.Text<>s) then AddChangeType('LINK');
      GgForm_eUrlQr.Text:=s;
    end
    else begin
{$ifndef USE_SMARTLINK}
      if(GgForm_bGGView.Checked) and (GgForm_eUrlQr.Text<>sNew) then AddChangeType('LINK');
{$else}
      if(GgForm_bGGView.Checked) and (GgForm_eUrlQr.Text<>sNew) then AddChangeType('SMART');
{$endif}
      GgForm_eUrlQr.Text:=sNew;
    end;
{$ifndef USE_SMARTLINK}
    if(s<>'') then GgForm_eUrlQr.Text:=s;
{$endif}
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['StagesTotalCount'].Value); //toto je i v tom 2. volani
    i:=StrToInt(s);
    if(GgForm_bGGView.Checked) and (GgForm_bGGView.Checked)
      and (GgForm_cbCount.ItemIndex<>i-1) then AddChangeType('NUM');
    GgForm_cbCount.ItemIndex:=i-1;
    SerieChange(GgForm_cbCount);
    sNew:=UtfToAnsi(XML.Root.Items.Itemnamed['Description'].Value); //toto je i v tom 2. volani
    //tady asi muze byt problem s radkovanim, je jinak nez v zobrazenem textu
    //proto to porovname az po zapisu do memo pole
    s:=Trim(GgForm_mText.Lines.Text);
    GgForm_mText.Lines.Text:=Trim(sNew);
    if(GgForm_bGGView.Checked) and (GgForm_mText.Lines.Text<>s) then begin
      //{$ifdef DEBUG_HELPER} LDH('Stary text="'+s+'"'); {$endif}
      //{$ifdef DEBUG_HELPER} LDH('Novy text ="'+GgForm_mText.Lines.Text+'"'); {$endif}
      AddChangeType('TXT');
    end;
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['CreatedUtc'].Value);       //datum a cas vytvoreni
    {$ifdef DEBUG_HELPER} LDH('CreatedUtc='+s); {$endif}
    iYear:=StrToIntDef(Copy(s,1,4),0);
    iMon:=StrToIntDef(Copy(s,6,2),0);
    iDay:=StrToIntDef(Copy(s,9,2),0);
    dt:=0;
    TryEncodeDate(iYear,iMon,iDay,dt);
    if(GgForm_eId.Text='') then GgForm_dtCreate.Date:=dt;
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['IsArchived'].Value);       //archivovana
    if(GgForm_bGGView.Checked) then begin //doplnime ARCH do priznaku zmen
      if(GgForm_bArchiv.Checked<>(LowerCase(s)='true')) then AddChangeType('ARCH');
    end;
    GgForm_bArchiv.Checked:=(LowerCase(s)='true');
  finally
    Xml.Free();
  end;
end;

procedure GetLabsInfo(sLabId,sXml:String);      /////nacte informace o vsech labkach v serii
var s,sUrl,sNew,sImgUrl,sVideo,sImgUrlAward,sVideoAward,sMessageAward,sQuestion:string;
    Xml:TJclSimpleXML;
    elem,eItems: TJclSimpleXMLElem;
    i,idx:integer;
    x,y:extended;
begin
  if(sXml='') then begin //pokud neni zadany string s XML, nacteme jej
    sUrl:='https://labs-api.geocaching.com/Api/Adventures/'+sLabId;
    {$ifdef DEBUG_HELPER} LDH('1. URL='+sUrl); {$endif}
    HttpAsk('GET',sUrl,'','',sXml);
    StringToFile(sXml,GetOfflineDir()+'ApiLabsIno.xml');
  end;
  CmpGetForm(); //nacist data z formulare pro kontrolu poradi labek
  Xml:=TJclSimpleXml.Create();
  try
    //parsujeme XML
    Xml.LoadFromString((sXml));
    CheckXmlVersionDetail(Xml);
    CmpGetXml(Xml); //nacteme dat pro kontrolu poradi labek
    //GgForm_butLabOrder.Enabled:=false;
    {b:=}CmpSetLabIndex(); //nastav poradi labek v nove i stare serii
    //pokud neni stejne poradi ve stare a nove verzi, zpristupnime tlacitko
    for i:=0 to rCmpNew.nCount-1 do begin
      if(rCmpNew.Items[i].idx<>i) and (GgForm_bGGView.Checked) then begin
        GgForm_butLabOrder.Enabled:=true;
        AddChangeType('ORD');
        break;
      end;
    end;
    for i:=0 to MAX_LAB do aLabOld[i]:=aLab[i];   //abychom porovnavali se starym stavem
    GgForm_eIdTag.Text:=XML.Root.Items.Itemnamed['Id'].Value;
    sLabId:=GgForm_eIdTag.Text;
    //#### pro id=0f088495-bfac-4285-ae87-9be7b89eed03 to tu nejde, kdyz je pouzit
    //#### prevod do ANSI, proto tu musi byt UTF a do ANSI se prevede az jednotlivy string
    sNew:=UtfToAnsi(XML.Root.Items.Itemnamed['OwnerUsername'].Value);
    //if(GgForm_bGGView.Checked) and (GgForm_eNick.Text<>sNew) then GgForm_eChangeGpx.Text:=GgForm_eChangeGpx.Text+' ???';
    GgForm_eNick.Text:=sNew;
    butOwnerIdOnClick(nil);
    //{$ifdef DEBUG_HELPER} LDH('AAA'); {$endif}
    //popis, jmeno a pocet lanek v serii je i v BasicInfo, ale pro pripad, ze je
    //nacitano ze souboru, tak ho nacteme i odtud
    GgForm_mText.Lines.Text:=Trim(UtfToAnsi(XML.Root.Items.Itemnamed['Description'].Value));
    GgForm_eNameApi.Text:=Trim(UtfToAnsi(XML.Root.Items.Itemnamed['Title'].Value));
    //v BasicInfo je to pod <StagesTotalCount>
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['TotalGeocachesCount'].Value);
    if(s<>'') then GgForm_cbCount.ItemIndex:=StrToInt(s)-1;
    //{$ifdef DEBUG_HELPER} LDH('===========ownerid nacten=============='); {$endif}
    eItems:=XML.Root.Items.Itemnamed['GeocacheSummaries'];
    s:=UtfToAnsi(XML.Root.Items.Itemnamed['IsLinear'].Value);       //sekvencni
    //{$ifdef DEBUG_HELPER} LDH('seq='+s); {$endif}
    if(GgForm_eId.Text<>'') then begin //doplnime SEQ do priznaku zmen
      if(GgForm_bSeq.Checked<>(LowerCase(s)='true')) then AddChangeType('SEQ');
    end;
    GgForm_bSeq.Checked:=(LowerCase(s)='true');
    //{$ifdef DEBUG_HELPER} LDH('BBB'); {$endif}
    for i:=0 to eItems.items.count-1 do begin
      GgForm_cbLabView.ItemIndex:=i;
      cbLabViewOnChange(GgForm_cbLabView);
      elem:=eItems.items[i];
      //testujeme proti hodnotam, ktere jsou u spravnych labek
      s:=Trim(UtfToAnsi(elem.Items.Itemnamed['Title'].Value));
      idx:=rCmpNew.Items[i].idx;
      {$ifdef DEBUG_HELPER} LDH('Name='+aLabOld[idx].sName+' <> '+s); {$endif}
      if(GgForm_bGGView.Checked) and (aLabOld[idx].sName<>s) then  AddChangeType('NAME');
      GgForm_eLabName.Text:=s;          //jmeno labky
      //{$ifdef DEBUG_HELPER} LDH('jmeno='+GgForm_eLabName.Text); {$endif}
      GgForm_eLabIdOrd.Text:=Trim(UtfToAnsi(elem.Items.Itemnamed['Id'].Value));            //Id labky (ne cele serie!)
      {$ifdef DEBUG_HELPER} LDH('ID labky='+GgForm_eLabIdOrd.Text); {$endif}
      GgForm_mLabText.Lines.Text:=Trim(UtfToAnsi(elem.Items.Itemnamed['Description'].Value));    //popis labky
      //{$ifdef DEBUG_HELPER} LDH('popis='+GgForm_mLabText.Lines.Text); {$endif}
      //{$ifdef DEBUG_HELPER} LDH('EEE'); {$endif}
      s:=UtfToAnsi(elem.Items.Itemnamed['GeofencingRadius'].Value);
      //{$ifdef DEBUG_HELPER} LDH('radius='+s); {$endif}
      //{$ifdef DEBUG_HELPER} LDH('FFF'); {$endif}
      sQuestion:=UtfToAnsi(elem.Items.Itemnamed['Question'].Value);       //otazka
      //{$ifdef DEBUG_HELPER} LDH('dotaz='+s); {$endif}
      //{$ifdef DEBUG_HELPER} LDH('GGG'); {$endif}
      if(GgForm_bQuestion.Checked) then
        GgForm_mLabText.Lines.Text:=GgForm_mLabText.Lines.Text+CRLF+CRLF+'['+sQuestion+']';
      sImgUrl:=UtfToAnsi(elem.Items.Itemnamed['KeyImageUrl'].Value);  //odkaz na obrazek
      sVideo:=UtfToAnsi(elem.Items.Itemnamed['DescriptionVideoYouTubeId'].Value);  //odkaz na video
      sImgUrlAward:=UtfToAnsi(elem.Items.Itemnamed['AwardImageUrl'].Value);  //odkaz na obrazek po otazce
      sMessageAward:=UtfToAnsi(elem.Items.Itemnamed['CompletionAwardMessage'].Value);  //zprava po zodpovezeni otazky
      sVideoAward:=UtfToAnsi(elem.Items.Itemnamed['AwardVideoYouTubeId'].Value);  //odkaz na video po otazce
    //{$ifdef DEBUG_HELPER} LDH('HHH'); {$endif}
      elem:=elem.Items.Itemnamed['Location']
      if(elem.Items.Count<3) then begin
        ShowMessage('ERR: '+IntToStr(i+1)+'. LABka v serii neobsahuje souradnice');
      end
      else begin
        //{$ifdef DEBUG_HELPER} LDH('III'); {$endif}
        //{b:=}getJsonString(elem,'Latitude',s);
        s:=elem.Items.Itemnamed['Latitude'].Value; //souradnice
        //{$ifdef DEBUG_HELPER} LDH('JJJ'); {$endif}
        //{$ifdef DEBUG_HELPER} LDH('lat='+s); {$endif}
        GgForm_eLabCoord.Text:=s+', '+elem.Items.Itemnamed['Longitude'].Value;
        //{$ifdef DEBUG_HELPER} LDH('KKK'); {$endif}
        //{$ifdef DEBUG_HELPER} LDH('lat; lon='+s); {$endif}
      end;
      {$ifdef DEBUG_HELPER} LDH('IIII title='+aLab[i].sName); {$endif}
      SaveLab(i);   //zaroven nastavi priznak zmeny, pokud je potreba
      {$ifdef DEBUG_HELPER} LDH('JJJJ '); {$endif}
      aLab[i].sQuestion:=sQuestion;
      aLab[i].sVideoId:=sVideo;
      aLab[i].sImgUrl:=sImgUrl;
      aLab[i].sMessageAward:=sMessageAward;
      aLab[i].sVideoIdAward:=sVideoAward;
      aLab[i].sImgUrlAward:=sImgUrlAward;
    //{$ifdef DEBUG_HELPER} LDH('LLL'); {$endif}
    end;
    //predvolime Czechia jako implicitni stat
    //zkusime pres webovou sluzbu najit stat podle GgForm_eLabCoord.Text
    ParseWgsStr(GgForm_eCoord.Text,x,y);
    sUrl:='http://www.geonames.org/findNearbyPlaceName?lat='+FloatToStr(x)+'&lng='+FloatToStr(y)
      //+'&style=FULL' //tohle doplni jeste dalsi uroven v <adminName1>, napr 'Hlavni mesto Praha', nadmorskou vysku, kontinent, ...
      ;
    {$ifdef DEBUG_HELPER} LDH('posilam: '+sUrl); {$endif}
    HttpAsk('GET',sUrl,'','',s);
    {$ifdef DEBUG_HELPER} LDH('odpoved z geonames.org: '+CRLF+s); {$endif}
    Fetch(s,'<countryName>');
    i:=GgForm_cbCountry.Items.IndexOf(Fetch(s,'</countryName>'));
    if(i>-1) then begin
      //zkontrolujeme, zda se stat zmenil, pokud ne, nedelame s tim nic
      if(GgForm_cbCountry.ItemIndex<>i) then begin
        GgForm_cbCountry.ItemIndex:=i;
        cbCountryOnChange(nil);
      end;
    end;
    GgForm_cbLabView.ItemIndex:=0;
    cbLabViewOnChange(GgForm_cbLabView);
  finally
    Xml.Free();
  end;
  //{$ifdef DEBUG_HELPER} LDH('MMM'); {$endif}
end;

